###############################################################################################
# $Id: clear_plans_act.py,v 1.3 2002/09/08 11:26:57 chakie Exp $
###############################################################################################

import scenario
from action      import Action
import plan.factory


## def create ():
##     """This function is a factory for creating instances of the class 'ClearPlansAct'. Use this when you need
##     to create instances. The new instance is returned."""
##     # create a new instance and return it
##     return ClearPlansAct ()


class ClearPlansAct (Action):
    """
    This class implements the immediate update 'clear plasn'. This is sent by the server when an unit
    needs to get rid of all plans that it currently has. All plans are simply removed and nothing
    else done.."""

    def __init__ (self, step=-1, unitid=-1):
        """Initializes the instance."""
        # call superclass constructor
        Action.__init__ (self, "clear_plans_act", step )

        # store all data
        self.unitid = unitid
        

    def extract (self, parameters):
        """Extracts the data for the command. """
        # parse out the data
        self.step   = int ( parameters[0] )
        self.unitid = int ( parameters[1] )
        
        
    def execute (self):
        """Executed the action. Finds the affected unit and just clears all plans."""
        
        # get the unit with the given id 
        unit = scenario.info.units [ self.unitid ]

        # clear the plans
        unit.setPlans ( [] )
        
 
    def toString (self):
        """Returns a string representation of the command, suitable for sending over a socket."""
        # create a string and return
        return "%s %d %d\n" % ( self.getName (), self.step, self.unitid, )


    def __str__ (self):
        """Convenience wrapper for toString() suitable for using when debugging and printing the
        command to the screen. Will just call toString()."""
        return self.toString ()
    
     
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
