###############################################################################################
# $Id: factory.py,v 1.12 2002/09/08 11:26:57 chakie Exp $
###############################################################################################

# import all action  
from add_plan_act             import AddPlanAct
from change_combat_policy_act import ChangeCombatPolicyAct
from change_modifiers_act     import ChangeModifiersAct
from clear_plans_act          import ClearPlansAct
from damage_act               import DamageAct
from done_act                 import DoneAct
from end_game_act             import EndGameAct
from move_act                 import MoveAct
from rotate_act               import RotateAct
from set_mode_act             import SetModeAct
from set_target_act           import SetTargetAct


# our map of creators
creators = { 'add_plan_act'             : AddPlanAct,
             'change_combat_policy_act' : ChangeCombatPolicyAct,
             'change_modifiers_act'     : ChangeModifiersAct,
             'clear_plans_act'          : ClearPlansAct,
             'damage_act'               : DamageAct,
             'done_act'                 : DoneAct,
             'endgame_act'              : EndGameAct,
             'move_act'                 : MoveAct,
             'rotate_act'               : RotateAct,
             'settarget_act'            : SetTargetAct,
             'setmode_act'              : SetModeAct
             }
             

def create (parameters):
    """Creates a new action from the passed parameters. The parameter is a list of strings string
    that is supposed to be data for a action. The first word is the type of action, and the other
    are data for that specific upate. Based on the type a new instance is created and returned. """   

    # get the packet type
    type = parameters[0]

    # do we have such a plan?
    if not creators.has_key ( type ):
        # not an immediate plan
        return None
  
    # create a action based on the type
    action = creators [type] ()    

    # and let it extract whatever it needs from the parameters it got
    action.extract ( parameters[1:] )
    
    return action
  
    
       
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
