###############################################################################################
# $Id: factory.py,v 1.14 2002/08/13 13:25:44 chakie Exp $
###############################################################################################

# import all plan executors
import assault_exec
import change_combat_policy_exec
import change_mode_exec
import move_exec
import move_fast_exec
import skirmish_exec
import retreat_exec
import rotate_exec
import rout_exec
import wait_exec


# our map of creators
creators = { 'assault'            : assault_exec.create,
             'changecombatpolicy' : change_combat_policy_exec.create,
             'changemode'         : change_mode_exec.create,
             'move'               : move_exec.create,
             'movefast'           : move_fast_exec.create,
             'skirmish'           : skirmish_exec.create,
             'retreat'            : retreat_exec.create,
             'rotate'             : rotate_exec.create,
             'rout'               : rout_exec.create,
             'wait'               : wait_exec.create
             }
           

def create (unit, plan):
    """Creates a new plan executor from the passed plan. Based on the plan type a new executor is
    created and returned. """  

    # get the plan type
    type = plan.getName ()

    # do we have such a plan?
    if not creators.has_key ( type ):
        # unknown plan type
        raise "factory.create: unknown plan type: '%s'" % type

    # create a executor based on the plan type
    executor = creators [type] ( unit, plan )    
    
    return executor
    
       
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
