###############################################################################################
# $Id: wait_exec.py,v 1.3 2002/08/28 15:54:07 chakie Exp $
###############################################################################################

import scenario
import properties
from executor                    import Executor


def create (unit, plan):
    """This function is a factory for creating instances of the class 'WaitExec'. Use this when you need
    to create instances. The new instance is returned."""
    # create a new instance and return it
    return WaitExec (unit, plan)


class WaitExec (Executor):
    """
    This class executes the plan 'wait'. This plan is sent by clients when a unit has been
    ordered to wait for a certain amount of time. This executor will simply be delayed that amount
    of time and then it will be finished. No other action. The unit wil lnot gain fatigue.
    """

    def __init__ (self, unit, plan):
        """Initializes the instance."""
        # call superclass constructor
        Executor.__init__ ( self, unit, plan )

       
    def execute (self, step):
        """Executes the plan. Does nothing, when we get this far the plan is already executed, as
        the execution is the waiting! """

        # execution is finished, nothing to do at all
        self.finished = 1


#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
