###############################################################################################
# $Id: queue.py,v 1.3 2001/01/11 12:20:54 chakie Exp $
###############################################################################################

import sys

class Queue:
    """This class defines a simple queue into which elements can be enqueued and dequeued. The
    emptiness can also be tested."""
    
    def __init__(self):
        """Initializes the queue with initially no elements."""
        # no front or back initially
        self.front = self.back = None 
        
        # an empty generalized dictionary
        self.elements = {} 
  
    def isEmpty (self):
        """Checks wether the queue is empty or not."""
        # if no front, it must be empty
        return self.front == None 


    def dequeue (self):
        """Remove and return the front element. Raises an exception if the queue is empty."""
        # get element
        result = self.elements [ self.front ] 

        # delete it
        del self.elements [ self.front ] 

        # reinitialize self, if this is the last element
        if self.front == self.back:
            self.__init__ ()

        else:
            # otherwise decrement front
            self.front = self.front + 1 

        # return whatever we got
        return result


    def enqueue (self, item):
        """Adds 'item' to the back of the queue."""
        # is the queue empty?
        if self.isEmpty ():
            # yep, init first element index
            self.front = self.back = 0

        else:
            # increment index for this element
            self.back = self.back + 1

        # store element
        self.elements [self.back] = item 


    def getFront (self):
        """Returns the front element without removing it."""
        return self.elements [ self.front ]


    def size (self):
        """Returns the number of elements in the queue."""
        # do we have any elements at all?
        if self.isEmpty ():
            # nope
            return 0

        # just do a simple calculation
        return self.back - self.front + 1
    

if __name__ == '__main__':
    q = Queue()
    print q.size ()
    q.enqueue ( 1 )
    print q.size ()
    q.enqueue ( 1 )
    print q.size ()
    q.enqueue ( 1 )
    print q.size ()

    while not q.isEmpty ():
        q.dequeue ()
    print q.size ()
         
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
