###############################################################################################
# $Id: cease_fire.py,v 1.5 2002/09/08 11:26:58 chakie Exp $
###############################################################################################

import sys
import string
import pygame
import scenario
import constants
from   immediate      import Immediate

## def create ():
##     """This function is a factory for creating instances of the class 'CeaseFire'. Use this when you need
##     to create instances. The new instance is returned."""

##     # create a new instance and return it
##     return CeaseFire ()


class CeaseFire (Immediate):
    """
    This class implements the immediate update 'cease fire'. This updated means that the player sending
    it wants to end the battle and cease fire. It actually does nothing, it just sends the offer out
    to the player.

    TODO: how ask the other player?

    If the cease fire is accepted by the other player then the other party will respond with a
    EndGame immediate update.
    """


    def __init__ (self, player=-1):
        """Initializes the instance."""
        # call superclass constructor
        Immediate.__init__ (self, "ceasefire")
        
        # store the player too
        self.player = player


    def getPlayer (self):
        """Returns the player the update was created by."""
        return self.player
    

    def extract (self, parameters):
        """Extracts the data for the command. """ 
        # parse out the data
        self.player = int ( parameters[0] ) 
    

    def execute (self):
        """Executes the plan. Shows a message on the display of the other player.

        TODO: what should it do?
        """

        # are we the same player that sent the request?
        if self.player == scenario.local_player_id:
            # yes, we don't want to anything here, only the remote player has anything to do
            return

        # this should not be done for the ai
        if scenario.local_player_ai:
            # ai player, go away
            return
        
        # find the name of the remote player. note that the strings are reversed
        other = ['Union','Rebel'][scenario.local_player_id]

        # add the message we have to the messages
        scenario.messages.add ( "%s player offers you a cease fire" % other )
            


    def toString (self):
        """Returns a string representation of the command, suitable for sending over a socket."""
        # create a string and return
        return "%s %d\n" % ( self.getName (), self.player )


    def __str__ (self):
        """Convenience wrapper for toString() suitable for using when debugging and printing the
        command to the screen. Will just call toString()."""
        return self.toString ()
    
     
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
