###############################################################################################
# $Id: end_turn.py,v 1.2 2002/09/08 11:26:58 chakie Exp $
###############################################################################################

import string
import scenario
from   immediate  import Immediate

## def create ():
##     """This function is a factory for creating instances of the class 'EndTurn'. Use this when you need
##     to create instances. The new instance is returned."""

##     # create a new instance and return it
##     return EndTurn ()


class EndTurn (Immediate):
    """
    This class implements the packet 'end_turn'. This immediate is an update that tells the server
    how many plans it will be receiving now that the player has ended the current turn. So this
    immediate is sent as the first immediate when the client (not the server player) has finished
    orders, and contains only a single value as the 'payload'.

    Only the client player sends this update.
    """ 
    

    def __init__ (self, turn=-1):
        """Initializes the instance."""
        # call superclass constructor
        Immediate.__init__ (self, "endturn" )

        # store the number of plans and the ended turn
        self.turn = turn
        

    def extract (self, parameters):
        """Extracts the data for the command. The only data is the turn when the chat should take place."""
        # parse out the data
        self.turn  = int ( parameters[0] ) 


    def execute (self):
        """Sets a flag that indicates the the other player has ended the turn."""
      
        # we got an end turn, set the flag so that the state 'EndOrders' can check it later
        scenario.turn_ended = 1

        
    def getTurn (self):
        """Returns the turn that the other layer has ended."""
        return self.turn
    

    def toString (self):
        """Returns a string representation of the command, suitable for sending over a socket."""
        # create a string and return
        return "%s %d\n" % ( self.getName (), self.turn )


    def __str__ (self):
        """Convenience wrapper for toString() suitable for using when debugging and printing the
        command to the screen. Will just call toString()."""
        return self.toString ()
    
     
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
