###############################################################################################
# $Id: factory.py,v 1.4 2002/09/08 11:26:58 chakie Exp $
###############################################################################################

# import all updates
from chat       import Chat 
from cease_fire import CeaseFire
from end_turn   import EndTurn
from end_action import EndAction
from quit       import Quit
from surrender  import Surrender

# our map of creators
creators = { 'chat'       : Chat,
             'ceasefire'  : CeaseFire,
             'endturn'    : EndTurn,
             'endaction'  : EndAction,
             'quit'       : Quit,
             'surrender'  : Surrender
             }
             

def create (parameters):
    """Creates a new immediate update from the passed parameters. The parameter is a list of strings
    string that is supposed to be data for a update. The first word is the type of update, and the other
    are data for that specific upate. Based on the type a new instance is created and returned. """  

    # get the packet type
    type = parameters[0]

    # do we have such a plan?
    if not creators.has_key ( type ):
        # not an immediate plan
        return None
    
    # create a update based on the type
    update = creators [type] ()    

    # and let it extract whatever it needs from the parameters it got
    update.extract ( parameters[1:] )

    return update
    
       
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
