###############################################################################################
# $Id: quit.py,v 1.3 2002/09/08 11:26:58 chakie Exp $
###############################################################################################

import sys
import string
import constants
import pygame
import scenario
from   immediate  import Immediate


## def create ():
##     """This function is a factory for creating instances of the class 'Quit'. Use this when you need
##     to create instances. The new instance is returned."""

##     # return a new instance
##     return Quit ()


class Quit (Immediate):
    """
    This class implements the immediate plan 'quit'. Used when a player has quit.

    TODO: should also contain some kind of info for why that game was quit?
    """

    # static id for this class
    typeid = -1

    def __init__ (self, turn = -1 ):
        """Initializes the instance."""
        # call superclass constructor
        Immediate.__init__ (self, "quit" )


    def execute (self):
        """Executes the immediate plan. Sets a flag that indicates that the game has ended."""
        # set flag
        scenario.playing = constants.GAME_ENDED
        

    def toString (self):
        """Returns a string representation of the command, suitable for sending over a socket."""
        # create a string and return
        return "%s\n" % self.getName ()


    def __str__ (self):
        """Convenience wrapper for toString() suitable for using when debugging and printing the
        command to the screen. Will just call toString()."""
        return self.toString ()
    
     
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
