###############################################################################################
# $Id: disorganized_limbered.py,v 1.1 2002/06/28 08:57:28 chakie Exp $
###############################################################################################

from mode import Mode


class DisorganizedLimbered (Mode):
    """
    This implements the mode 'disorganized'. It is used by all units when they have retreated and
    means that the troops are still a little disorganized. After a while the troops will reform
    into 'formation' or some similar mode.
    """

    def __init__ (self):
        """Initializes the mode."""
        # call superclass
        Mode.__init__ ( self, "disorganizedlimbered", "disorganized" )

        # set the modes we change to
        self.onchangemode   = ""
        self.onmove         = ""
        self.onmovefast     = ""
        self.onrotate       = ""
        self.onhalt         = ""
        self.onretreat      = "retreatingartillery"
        self.ondone         = "limbered"
        self.onskirmish     = ""
        self.onmelee        = "meleeingartillery"
        self.onassault      = ""
        self.onchangepolicy = ""
        self.onwait         = ""
        self.onrally        = "limbered"
        
        # set a base fatigue
        self.base_fatigue = 1.0
    
    
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
