###############################################################################################
# $Id: mode_factory.py,v 1.18 2002/09/07 13:28:09 msa Exp $
###############################################################################################

from changing_to_column      import ChangingToColumn
from changing_to_formation   import ChangingToFormation
from column                  import Column
from column_move             import ColumnMove
from column_move_fast        import ColumnMoveFast
from column_skirmish         import ColumnSkirmish
from formation               import Formation
from formation_move          import FormationMove
from formation_skirmish      import FormationSkirmish
from formation_assault       import FormationAssault
from mounted                 import Mounted
from mounted_move            import MountedMove
from mounted_move_fast       import MountedMoveFast
from mounted_skirmish        import MountedSkirmish
from mounted_assault         import MountedAssault
from mounting                import Mounting
from disorganized_column     import DisorganizedColumn
from disorganized_formation  import DisorganizedFormation
from disorganized_limbered   import DisorganizedLimbered
from disorganized_unlimbered import DisorganizedUnlimbered
from disorganized_mounted    import DisorganizedMounted
from disorganized_unmounted  import DisorganizedUnmounted
from dismounted              import Dismounted
from dismounted_move         import DismountedMove
from dismounted_skirmish     import DismountedSkirmish
from dismounting             import Dismounting
from limbered                import Limbered
from limbered_move           import LimberedMove
from limbering               import Limbering
from unlimbered              import Unlimbered
from unlimbered_skirmish     import UnlimberedSkirmish
from unlimbering             import Unlimbering
from retreating_infantry     import RetreatingInfantry
from retreating_cavalry      import RetreatingCavalry
from retreating_artillery    import RetreatingArtillery
from routed_move_infantry    import RoutedMoveInfantry
from routed_move_cavalry     import RoutedMoveCavalry
from routed_move_artillery   import RoutedMoveArtillery
from routed_infantry         import RoutedInfantry
from routed_cavalry          import RoutedCavalry
from routed_artillery        import RoutedArtillery
from meleeing_infantry       import MeleeingInfantry
from meleeing_cavalry        import MeleeingCavalry
from meleeing_artillery      import MeleeingArtillery

# a map of all modes
modes = {
    'column':                  Column,
    'columnmove':              ColumnMove,
    'columnmovefast':          ColumnMoveFast,
    'columnskirmish':          ColumnSkirmish,
    'changingtocolumn':        ChangingToColumn,
    'formation':               Formation,
    'formationmove':           FormationMove,
    'formationskirmish':       FormationSkirmish,
    'formationassault':        FormationAssault,
    'changingtoformation':     ChangingToFormation,
    'mounted':                 Mounted,
    'mountedmove':             MountedMove,
    'mountedmovefast':         MountedMoveFast,
    'mountedskirmish':         MountedSkirmish,
    'mountedassault':          MountedAssault,
    'mounting':                Mounting,
    'dismounted':              Dismounted,
    'dismountedmove':          DismountedMove,
    'dismountedskirmish':      DismountedSkirmish,
    'dismounting':             Dismounting,
    'disorganizedcolumn':      DisorganizedColumn,
    'disorganizedformation':   DisorganizedFormation,
    'disorganizedlimbered':    DisorganizedLimbered,
    'disorganizedunlimbered':  DisorganizedUnlimbered,
    'disorganizedmounted':     DisorganizedMounted,
    'disorganizedunmounted':   DisorganizedUnmounted,
    'limbered':                Limbered,
    'limbering':               Limbering,
    'limberedmove':            LimberedMove,
    'unlimbered':              Unlimbered,
    'unlimberedskirmish':      UnlimberedSkirmish,
    'unlimbering':             Unlimbering,
    'retreatinginfantry':      RetreatingInfantry,
    'retreatingcavalry':       RetreatingCavalry,
    'retreatingartillery':     RetreatingArtillery,
    'routedartillery':         RoutedArtillery,
    'routedcavalry':           RoutedCavalry,
    'routedartillery':         RoutedArtillery,
    'routedmoveinfantry':      RoutedMoveInfantry,
    'routedmovecavalry':       RoutedMoveCavalry,
    'routedmoveartillery':     RoutedMoveArtillery,
    'meleeinginfantry':        MeleeingInfantry,
    'meleeingcavalry':         MeleeingCavalry,
    'meleeingartillery':       MeleeingArtillery,
}

def createMode (mode):
    """This function works as a factory for creating instances of Mode subclases based on the passed
    string. The string should be the name of the wanted mode, just as the method 'getName()' on the
    mode would return. A new Mode subclass is returned."""
     
    # just create a new mode based on the name
    try:
        return modes [mode]()
    except:
        # no such mode?
        raise ValueError ( "mode '%s' is unknown to the factory" % mode )


#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
