###############################################################################################
# $Id: retreating_artillery.py,v 1.11 2002/06/28 08:57:28 chakie Exp $
###############################################################################################

from mode import Mode


class RetreatingArtillery (Mode):
    """
    This implements the mode 'retreating'. It is used by artillery units when they are retreating,
    either by having taken a punishment or when the player has chosen to retreat the unit
    manually. As long as the unit is moving it will keep this state, and when it stops it will get
    the state 'disorganized'.  """

    def __init__ (self):
        """Initializes the mode."""
        # call superclass
        Mode.__init__ ( self, "retreatingartillery", "retreating" )

        # set the modes we change to
        #self.onchangemode = ""
        #self.onmove       = ""
        #self.onmovefast   = ""
        #self.onrotate     = ""
        #self.onhalt       = ""
        #self.onretreat    = ""
        #self.onskirmish   = ""
        self.ondone       = "disorganizedlimbered"
        self.onmelee      = "meleeingartillery"
        self.onassault    = ""
        self.onchangepolicy = ""
        self.onwait         = ""
        
        # set a base fatigue
        self.base_fatigue = 2.0
    
    
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
