###############################################################################################
# $Id: calculate_action_layer.py,v 1.5 2002/04/09 14:07:55 chakie Exp $
###############################################################################################

import sys
import pygame
import pygame.image
from pygame.locals   import *
from dialog_layer    import DialogLayer
import scenario
import properties


class CalculateActionLayer(DialogLayer):
    """
    This class defines a layer that plugs into the PlayField. It is used when the server is
    calculating the action data. It simply shows the user a static screen. Nothing fancy. Reacts to
    nothing.
    """

    def __init__ (self, name):
        "Initializes the layer."
        # call superclass constructor, but with no button
        DialogLayer.__init__ ( self, name, 300, 100, None)

        # set a nice title
        self.title = self.createLabel ( "Computing action..." )

    
    def customPaint (self):
        """Paints the layer by painting the contents and the calling the superclass method for doing
        the frame painting."""
        
        # paint the title. the coordinates are inherited, and refer to the topleft corner of the
        # content area we're given
        scenario.sdl.blit ( self.title, ( self.x + self.borderx, self.y + self.bordery ))
       
        
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
